package com.zhongzheng.modules.activity.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.github.pagehelper.Page;
import com.zhongzheng.modules.activity.bo.ActivityGradePrivilegeAddBo;
import com.zhongzheng.modules.activity.bo.ActivityGradePrivilegeQueryBo;
import com.zhongzheng.modules.activity.bo.ActivityGradePrivilegeEditBo;
import com.zhongzheng.modules.activity.domain.ActivityGradePrivilege;
import com.zhongzheng.modules.activity.mapper.ActivityGradePrivilegeMapper;
import com.zhongzheng.modules.activity.vo.ActivityGradePrivilegeVo;
import com.zhongzheng.modules.activity.service.IActivityGradePrivilegeService;

import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 等级积分特权类型：优惠券，折扣券等类型Service业务层处理
 *
 * @author change
 * @date 2021-05-20
 */
@Service
public class ActivityGradePrivilegeServiceImpl extends ServiceImpl<ActivityGradePrivilegeMapper, ActivityGradePrivilege> implements IActivityGradePrivilegeService {

    @Override
    public ActivityGradePrivilegeVo queryById(Long id){
        ActivityGradePrivilege db = this.baseMapper.selectById(id);
        return BeanUtil.toBean(db, ActivityGradePrivilegeVo.class);
    }

    @Override
    public List<ActivityGradePrivilegeVo> queryList(ActivityGradePrivilegeQueryBo bo) {
        LambdaQueryWrapper<ActivityGradePrivilege> lqw = Wrappers.lambdaQuery();
        lqw.eq(bo.getGradeId() != null, ActivityGradePrivilege::getGradeId, bo.getGradeId());
        lqw.eq(StrUtil.isNotBlank(bo.getPriType()), ActivityGradePrivilege::getPriType, bo.getPriType());
        lqw.eq(bo.getCouponPrice() != null, ActivityGradePrivilege::getCouponPrice, bo.getCouponPrice());
        lqw.eq(bo.getEndTimeSum() != null, ActivityGradePrivilege::getEndTimeSum, bo.getEndTimeSum());
        lqw.eq(bo.getQuantity() != null, ActivityGradePrivilege::getQuantity, bo.getQuantity());
        return entity2Vo(this.list(lqw));
    }

    /**
    * 实体类转化成视图对象
    *
    * @param collection 实体类集合
    * @return
    */
    private List<ActivityGradePrivilegeVo> entity2Vo(Collection<ActivityGradePrivilege> collection) {
        List<ActivityGradePrivilegeVo> voList = collection.stream()
                .map(any -> BeanUtil.toBean(any, ActivityGradePrivilegeVo.class))
                .collect(Collectors.toList());
        if (collection instanceof Page) {
            Page<ActivityGradePrivilege> page = (Page<ActivityGradePrivilege>)collection;
            Page<ActivityGradePrivilegeVo> pageVo = new Page<>();
            BeanUtil.copyProperties(page,pageVo);
            pageVo.addAll(voList);
            voList = pageVo;
        }
        return voList;
    }

    @Override
    public Boolean insertByAddBo(ActivityGradePrivilegeAddBo bo) {
        ActivityGradePrivilege add = BeanUtil.toBean(bo, ActivityGradePrivilege.class);
        validEntityBeforeSave(add);
        return this.save(add);
    }

    @Override
    public Boolean updateByEditBo(ActivityGradePrivilegeEditBo bo) {
        ActivityGradePrivilege update = BeanUtil.toBean(bo, ActivityGradePrivilege.class);
        validEntityBeforeSave(update);
        return this.updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(ActivityGradePrivilege entity){
        //TODO 做一些数据校验,如唯一约束
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return this.removeByIds(ids);
    }

    @Override
    public void removeByGrade(Long id) {
        baseMapper.deleteByGrade(id);
    }
}
